package main

const USAGE = "takeown: delegate file ownership takeover to unprivileged users\n" +
"===============================================================\n" +
"\n" +
"Brief usage:\n" +
"\n" +
"takeown [-T] [-r] [-s] PATH\n" +
"takeown [-T] -a USER PATH...\n" +
"takeown [-T] -l PATH...\n" +
"takeown [-T] -d USER PATH...\n" +
"\n" +
"INTRO\n" +
"-----\n" +
"\n" +
"`takeown` allows administrators to delegate taking ownersip ownership of files\n" +
"and directories to non-administrators.  It uses the set-uid bit to gain the\n" +
"necessary privileges to do so.\n" +
"\n" +
"Example: the administrator wants to let the user `pablo` take over ownership\n" +
"of files in `/var/shared/Incoming`.  To that effect, the administrator runs:\n" +
"\n" +
"takeown -a pablo /var/shared/Incoming\n" +
"\n" +
"Once he has done so, the user `pablo` can run the command:\n" +
"\n" +
"takeown /var/shared/Incoming/some-file.txt\n" +
"\n" +
"and `takeown` will change the owner of the file `some-file.txt` to `pablo`.\n" +
"\n" +
"Each delegation is recorded in a file `.takeown.delegations` stored in the\n" +
"root directory of the volume containing the delegated file / directory.\n" +
"\n" +
"Delegations recorded on a volume only apply to files and directories\n" +
"stored in the volume.  Delegations do not propagate across mount points.\n" +
"If a user has been granted a delegation on a directory, he will be\n" +
"authorized to take ownership of any files contained in that directory,\n" +
"so long as said files are in the same volume.\n" +
"\n" +
"The flag `-r` in the takeown command induces takeown to grant ownership to the\n" +
"invoking user recursively across all files and subdirectories of the specified\n" +
"paths.  The caveat about not crossing mount points applies -- if another\n" +
"volume is mounted within the path specified to a `takeown -r` command, that\n" +
"volume will be skipped silently.\n" +
"\n" +
"For security reasons, attempts by an authorized user to take ownership of\n" +
"a volume or ownership of the delegation record file will be silently ignored.\n" +
"\n" +
"DELEGATING OWNERSHIP TO AN USER\n" +
"-------------------------------\n" +
"\n" +
"To allow a user to take ownership of files under a directory, or specific\n" +
"files, run:\n" +
"\n" +
"takeown username /path/to/directory/or/file...\n" +
"\n" +
"This will delegate the taking of ownership to the user, allowing him to run\n" +
"`takeown` to take ownership of any file within the specified paths.\n" +
"\n" +
"WARNING: if you delegate the taking of ownership of a volume to a user,\n" +
"that user may take ownership of the volume itself, and then remove the\n" +
"delegation store.  This is not a security issue -- it does not grant the\n" +
"user any extra privileges -- but it does prevent future uses of `takeown`\n" +
"by unprivileged users in that volume.\n" +
"\n" +
"REVOKING DELEGATIONS\n" +
"--------------------\n" +
"\n" +
"To revoke an established delegation, use the following command:\n" +
"\n" +
"takeown -d username /delegated/path\n" +
"\n" +
"This removes the specific delegation established for that user name.\n" +
"\n" +
"LISTING DELEGATIONS\n" +
"-------------------\n" +
"\n" +
"Any user may list established delegations with the command:\n" +
"\n" +
"takeown -l [PATH]\n" +
"\n" +
"However, only the administrator may list delegations for all users.  Other\n" +
"users will only get to see the delegations assigned to him.\n" +
"\n" +
"SIMULATING TAKING OWNERSHIP\n" +
"---------------------------\n" +
"\n" +
"The action of taking ownership can be simulated with flag `-s`.  In this mode,\n" +
"`takeown` will print what it would do rather than changing the file system.\n" +
"\n" +
"TRACING\n" +
"-------\n" +
"\n" +
"If a file `/.trace` exists in the root directory, the user is allowed to\n" +
"specify the flag `-T`, which causes the program to print tracing information,\n" +
"useful to debug problems with the program.\n" +
"\n" +
"LICENSE\n" +
"-------\n" +
"\n" +
"This program is published under the GNU GPL version 3 or later.\n"
